﻿using DataEntity;
using Sklad.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sklad.Presentation
{
    /// <summary>
    /// Interaction logic for pgPrehMat.xaml
    /// </summary>
    public partial class pgPrehMat : Page
    {

        private pgPrehMatVM _datacontext;
        private SkladContext _context = Globals._context;

        public pgPrehMat()
        {
            InitializeComponent();
            _datacontext = new pgPrehMatVM();
            this.DataContext = _datacontext;
        }

        private void PotvrditCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
             e.CanExecute = Globals.IsValid(gbLevy);
           // e.CanExecute = true;
        }

        private void Potvrdit(object sender, ExecutedRoutedEventArgs e)
        {
            //_context.SaveChanges();
            Globals.SaveChanges();
            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Prohlizeni;
        }

        private void btnEditMat_Click(object sender, RoutedEventArgs e)
        {
            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Editace;
        }

        private void btnAddMat_Click(object sender, RoutedEventArgs e)
        {
            Material material = new Material();

            material.Datum = DateTime.Today;
            material.MnozPoj = 1;
            material.MernaJednotka = _datacontext.MerneJednotkyCol[0];

            _context.Materialy.Add(material); // spojit s databazi
            _datacontext.MaterialyCol.Add(material); //pridat do kolekce ve viewmodelu

            _datacontext.MaterialSelected = material;
            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Pridavani;

            dgMaterialy.ScrollIntoView(_datacontext.MaterialSelected);

        }

        private void btnStorno_Click(object sender, RoutedEventArgs e)
        {

            Material mat = _datacontext.MaterialSelected;

            if  (_datacontext.AktualniRezim==pgPrehMatVM.Rezimy.Pridavani)
            {
                _context.Entry(mat).State = System.Data.Entity.EntityState.Detached;
                _datacontext.MaterialyCol.Remove(mat);
                mat = null;
            }

            if (_datacontext.AktualniRezim==pgPrehMatVM.Rezimy.Editace)
            {
                Globals.RollBack();
            }

            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Prohlizeni;

        }
    }
}
